"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkDependencies = void 0;
const fs_1 = require("fs");
function transformDependency(dependency) {
    let result = {};
    result[dependency.name] = `~${dependency.version}`;
    return result;
}
function checkDependencies({ deepJsonFilePath, packageJsonPath, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const deepJson = JSON.parse(yield fs_1.promises.readFile(deepJsonFilePath, 'utf8'));
        const packageJson = JSON.parse(yield fs_1.promises.readFile(packageJsonPath, 'utf8'));
        let updated = false;
        for (const dep of deepJson.dependencies) {
            if (!packageJson.dependencies[dep.name]) {
                const transformedDependency = transformDependency(dep);
                packageJson.dependencies = Object.assign(Object.assign({}, packageJson.dependencies), transformedDependency);
                updated = true;
            }
        }
        if (updated) {
            yield fs_1.promises.writeFile(packageJsonPath, JSON.stringify(packageJson, null, 2));
            console.log('Updated package.json with missing dependencies from deep.json');
        }
        else {
            console.log('No missing dependencies found');
        }
    });
}
exports.checkDependencies = checkDependencies;
